<template>
  <div
    id="player"
    :style="`
      width: ${width}px;
      height: ${height}px;
      transform: translate(${position.x}px, ${position.y}px);
    `"
  >
    <div class="sprite-container">
      <sprite
        v-if="active"
        src="/spritesheets/megaman.png"
        :spritesheetRows="4"
        :spritesheetCols="4"
        :size="spriteSize"
        :animations="animations"
        :current-animation="currentAnimation"
        :flip="!facesRight"
        ref="sprite"
      />
    </div>
  </div>
</template>

<script>
export default {
  props: {
    keyboardInput: Object,
    level: Object,
    startPosition: {
      type: Object,
      default: { x: 200, y: -84 },
    },
  },
  data() {
    return {
      active: false,
      width: 52,
      height: 84,
      spriteSize: 112,
      tilesize: this.$store.state.tilesize,
      facesRight: true,
      movementSpeed: 600,
      movementX: 0,
      movementY: 0,
      position: { x: 200, y: -84 },
      jumpButtonDown: false,
      isJumpingOrFalling: true,
      fallStartCoords: { left: {}, right: {}},
      jumpStrength: 1500,
      animations: {
        idle: { start: 0, end: 0 },
        run: { start: 4, end: 7},
        jump: {start: 2, end: 2},
      },
      currentAnimation: 'idle',
    };
  },
  mounted() {
    setTimeout(() => {
      this.position = {...this.startPosition};
      this.active = true;
    }, 20);
  },
  methods: {
    update(deltaTime) {
      if (this.active) {
        this.movementHandler();
        this.jumpHandler(deltaTime);
        this.floorDetection(deltaTime);
        this.ceilingDetection(deltaTime);
        this.wallDetection(deltaTime);
        this.animationHandler();
        this.$refs.sprite.update(deltaTime);

        // actually move the player
        this.position.x += this.movementX * deltaTime;
        this.position.y += this.movementY * deltaTime;
      }
    },
    movementHandler() {
      if (this.keyboardInput.left && this.keyboardInput.right) {
        this.movementX = 0;
        return;
      }

      if (this.keyboardInput.left) {
        this.facesRight = false;
        this.movementX = -this.movementSpeed;
        return;
      }

      if (this.keyboardInput.right) {
        this.facesRight = true;
        this.movementX = this.movementSpeed;
        return;
      }

      this.movementX = 0;
    },
    jumpHandler(deltaTime) {
      if (this.keyboardInput.jump && !this.isJumpingOrFalling && !this.jumpButtonDown) {
        this.movementY = -this.jumpStrength;
        this.isJumpingOrFalling = true;
        this.jumpButtonDown = true;
        return;
      }

      if (!this.keyboardInput.jump && !this.isJumpingOrFalling) {
        this.jumpButtonDown = false;
      }

      if (this.isJumpingOrFalling) {
        this.movementY += this.$store.state.gravity * deltaTime;

        if (this.movementY > this.$store.state.terminalVelocity) {
          this.movementY = this.$store.state.terminalVelocity;
        }
      }

      // respawn on fall to death
      if (this.position.y > this.tilesize * (this.$store.state.viewportRows + 2)) {
        this.position = {...this.startPosition};
      }
    },
    floorDetection(deltaTime) {
      const topLeft = {
        x: this.position.x,
        y: this.position.y + this.movementY * deltaTime,
      };
      const bottomLeft = {
        x: topLeft.x,
        y: topLeft.y + this.height,
      };
      const bottomRight = {
        x: topLeft.x + this.width - 1,
        y: bottomLeft.y,
      };

      const bottomLeftTile = this.getTileCoords(bottomLeft, true);
      const bottomRightTile = this.getTileCoords(bottomRight, true);

      // hacky way to make non blocking platforms work
      if (this.movementY <= 0 && this.isJumpingOrFalling) {
        this.fallStartCoords.left = bottomLeftTile;
        this.fallStartCoords.right = bottomRightTile;
      }

      if (this.movementY > 0) {
        if (this.getTileProperty('floor', bottomLeftTile) && bottomLeftTile.y !== this.fallStartCoords.left.y) {
          this.isJumpingOrFalling = false;
          this.position.y = (bottomLeftTile.y - 1) * this.tilesize + (this.tilesize - this.height);
          this.movementY = 0;
          return;
        }
        if (this.getTileProperty('floor', bottomRightTile) && bottomRightTile.y !== this.fallStartCoords.right.y) {
          this.isJumpingOrFalling = false;
          this.position.y = (bottomRightTile.y - 1) * this.tilesize + (this.tilesize - this.height);
          this.movementY = 0;
          return;
        }
      }
      if (this.movementY === 0) {
        if (!this.getTileProperty('floor', bottomLeftTile) && !this.getTileProperty('floor', bottomRightTile)) {
          this.isJumpingOrFalling = true;
          return;
        }
      }
    },
    ceilingDetection(deltaTime) {
      const topLeft = {
        x: this.position.x,
        y: this.position.y + this.movementY * deltaTime,
      };
      const topRight = {
        x: topLeft.x + this.width - 1,
        y: topLeft.y,
      };

      const topLeftTile = this.getTileCoords(topLeft);
      const topRightTile = this.getTileCoords(topRight);

      if (this.movementY < 0) {

        if (this.getTileProperty('blocking', topLeftTile)) {
          this.position.y = (topLeftTile.y + 1) * this.tilesize + 1;
          this.movementY = 0;
          return;
        }
        if (this.getTileProperty('blocking', topRightTile)) {
          this.position.y = (topRightTile.y + 1) * this.tilesize + 1;
          this.movementY = 0;
          return;
        }
      }
    },
    wallDetection(deltaTime) {
      const topLeft = {
        x: this.position.x + this.movementX * deltaTime,
        y: this.position.y,
      };
      const topRight = {
        x: topLeft.x + this.width,
        y: topLeft.y,
      }
      const bottomLeft = {
        x: topLeft.x,
        y: topLeft.y + this.height,
      };
      const bottomRight = {
        x: topRight.x,
        y: bottomLeft.y,
      };

      // LEFT
      if (this.movementX < 0) {
        // // check for out of bounds left
        if (topLeft.x < 0) {
          this.position.x = 0;
          this.movementX = 0;
          this.$parent.goToPreviousLevel();
        }

        // block check left
        const bottomLeftTile = this.getTileCoords(bottomLeft);
        const topLeftTile = this.getTileCoords(topLeft);
        if (this.getTileProperty('blocking', bottomLeftTile) || this.getTileProperty('blocking', topLeftTile)) {
          this.position.x = (bottomLeftTile.x + 1) * this.tilesize;
          this.movementX = 0;
        }
      }

      // RIGHT
      if (this.movementX > 0) {
        // // check for out of bounds right
        const maxX = this.tilesize * this.$store.state.viewportCols;
        if (topRight.x > maxX) {
          this.position.x = maxX - this.width;
          this.movementX = 0;
          this.$parent.goToNextLevel();
        }

        // block check right
        const bottomRightTile = this.getTileCoords(bottomRight);
        const topRightTile = this.getTileCoords(topRight);
        if (this.getTileProperty('blocking', bottomRightTile) || this.getTileProperty('blocking', topRightTile)) {
          this.position.x = bottomRightTile.x * this.tilesize - this.width;
          this.movementX = 0;
        }
      }
    },
    getTileCoords(position = {x: 0, y: 0}, floorDetect = false) {
      return {
        x: Math.floor(position.x / this.tilesize),
        y: Math.floor((position.y - (floorDetect ? 0 : 1)) / this.tilesize)
      };
    },
    getTileProperty(propertyName, position = {x: 0, y: 0}) {
      let result = false
      Object.entries(this.level).forEach(([key, tileGroup]) => {
        if (tileGroup[propertyName]) {
          tileGroup.positions.forEach(tilePosition => {
            if (tilePosition.x === position.x && tilePosition.y === position.y) {

              result = true;
            }
          })
        }
      });
      return result;
    },
    animationHandler() {
      if (this.isJumpingOrFalling) {
        this.currentAnimation = 'jump';
        return;
      }

      if (this.movementX !== 0) {
        this.currentAnimation = 'run';
        return;
      }

      this.currentAnimation = 'idle';
    },
  },
}
</script>

<style lang="scss">
#player {
  position: absolute;

  .sprite-container {
    position: absolute;
    bottom: -14px;
    left: 50%;
    transform: translateX(-50%);
  }
}
</style>